#!/bin/sh

# variables
if [ -z $1 ]
then
    echo -n "Where is the input data located : "
    read INPUT_DATA;
else
    INPUT_DATA=$1
fi

if [ -z $2 ]
then
    echo -n "Where should the result be save : "
    read SAVE_RESULT
else
    SAVE_RESULT=$2
fi

if [ -z $3 ]
then
    echo -n "Where to save the collision results : "
    read COLLISION
else
    COLLISION=$3
fi

if [ -z $4 ]
then
    echo -n "What is the size of the data set xGB, xMB : "
    read TESTSIZE
else
    TESTSIZE=$4
fi

if [ -z $5 ]
then
    echo -n "How many parts is it splited into : "
    read PARTS
else
    PARTS=$5
fi

if [ -z $6 ]
then
    echo -n "How many data-setss is there : "
    read DATASET
else
    DATASET=$6
fi

# Start the process
echo "Starting complte hash test with ${TESTSIZE} input file..."
echo "Compile hash test suit...."
cd ..
make cleanlib
make
echo "Hash test compiled..."
echo ""
echo ""
echo  ""

# Start the actual hash test on the files
for NAME in fnv16 fnv16a fnv32 fnv32a fnv64 fnv64a bobs32a bobs32b bobs64a bobs64b MD5 sha1 SFH
do
    echo "$NAME hashing is started..."
    
    # Check is the result file exist, if it do delete it, "I=data set" only one data set
    for I in 1
    do
        if [ -f ${SAVE_RESULT}/${TESTSIZE}_${NAME}_${I}.hash ] 
        then	
	    echo "Removing old hash results..."
            rm ${SAVE_RESULT}/${TESTSIZE}_${NAME}_${I}.hash
        fi
    done

    # Run the hash program for "I: data set" and "J: parts", only one data set
    for (( I = 1 ; I <= DATASET; I++ ))
    do
        for (( J = 0 ; J <= PARTS; J++ ))
	do	
		./hash_test ${INPUT_DATA}/random_${TESTSIZE}_${I}_part${J} $NAME 1 0 0 0 >> ${SAVE_RESULT}/${TESTSIZE}_${NAME}_${I}.hash
        done
	
	echo "Running collision test for ${NAME} on the file ${SAVE_RESULT}/${TESTSIZE}_${NAME}_${I}.hash..."

	echo "-------------------------------------" >> ${SAVE_RESULT}/${COLLISION}
	echo "---- ${NAME} ${TESTSIZE}_${NAME}_${I}.hash----" >> ${SAVE_RESULT}/${COLLISION}
	./collisions_counter.plx ${SAVE_RESULT}/${TESTSIZE}_${NAME}_${I}.hash >> ${SAVE_RESULT}/${COLLISION}
	echo "-------------------------------------" >> ${SAVE_RESULT}/${COLLISION}
    done
    
    echo "Hash test finished for ${NAME}..."
    echo
done

echo ""
echo "Hash test complet :-)"
echo ""