#!/usr/bin/perl

# Get command line parameters
my $file1 = shift;
my $file2 = shift;
my $page_size = shift;
my $pages = 0;
my $shared = 0;
my $page1 = 0;
my $page2 = 0;

# Check for parameters
if (($file1 eq "") or ($file2 eq "") or ($page_size <= 0)) {
    print "Compare to ram image file page2page V1\n";
    print "Usage: perl compare_files.plx <file1> <file2> <pagesize>\n\n";
    exit(1);
}

# Open the current input file
open(FILE1, "<$file1");
binmode(FILE1); 
open(FILE2, "<$file2");
binmode(FILE2); 

# Goes through the file reading one page a the time
while (read(FILE1, $page1, $page_size) != 0) {
    read(FILE2, $page2, $page_size);

    if (unpack("H*", $page1) eq unpack("H*", $page2)) {
	$shared++;
    }

    $pages++;
}

close(FILE1);
close(FILE2);

print "Page(s)                       : $pages\n";
printf("Precent of un-changed page(s) : %.1f \%\n", ($shared/$pages)*100);
printf("Precent of changed page(s)    : %.1f \%\n\n", 100-(($shared/$pages)*100));
