/*
  Ideas: print out offsets of shared pages, might be something we want to compare !
*/
#include <stdio.h>
#include <stddef.h>
#include <stdlib.h>
#include <string.h>
#include <search.h>
#include "hashmem.h"
#include "hash.h"
#define FRAMESIZE 4096

#define dprintf //printf
//#define dprintf printf

struct memdata *currentmem;
struct filechain *currentfile;
unsigned char page[FRAMESIZE];
unsigned char page2[FRAMESIZE];
unsigned char page3[FRAMESIZE];
unsigned char digest[16];
char hex_output[16*2 + 1];
FILE *fp,*fp1,*fp2,*argv1fp,*argv1fp2,*argv2fp,*argv2fp2;
int zeropagecount,di,debugcount,hashconflict;
struct memdata *lastnew;	
ENTRY e, *ep;

int main(int argc, char *argv[]){

	zeropagecount = debugcount = hashconflict = 0;	
	lastnew = NULL;

	hcreate(1000000);  // adjust this to the size of the file! filesize / 4096 (pt. klare den over 1,5 GB)
	int filedone,filechange;

	filedone = 1;
	filechange = 1;

	//	printf("\n%s\n",argv[2]);
	if(argv[1] == NULL){
		printf("Usage: hashmem memdump1 [memdump2] \n   or hashmem /dev/mem \n");
		exit(1);
	}
	if(argv[2] == NULL){
		filechange = 0;
		dprintf("\none file\n");
	} else {
		argv2fp = fopen(argv[2],"r");	
		argv2fp2 = fopen(argv[2],"r");
	}
 	
	argv1fp = fopen(argv[1],"r");	
	argv1fp2 = fopen(argv[1],"r");
	fp = argv1fp;
	fp2 = argv1fp2;
	
	while(filedone == 1){
		if((fread(page,FRAMESIZE,1,fp2) == 1)){
			dprintf("sted:%d\n",debugcount);
			debugcount++; 
			hash_data(page,4096, digest);
			for (di = 0; di < 16; ++di)
				sprintf(hex_output + di * 2, "%02x", digest[di]);
			
			e.key = hex_output; 
			ep = hsearch(e,FIND);
			
			if( ep == NULL)
				create_new_data();				
			else {
				hash_match(); 
			}
		} else {

			if(filechange == 1) {
				fp2 = argv2fp2;
				filechange = 0;
				dprintf("\nChange of file\n");
			} else {
				dprintf("\nDONE\n");
				filedone = 0;
			}
		}
	}		
	
	number_of_zeropages();
	write_data(zeropagecount);
	fclose(argv1fp);
	fclose(argv1fp2);
	if(argv[2] != NULL){
		fclose(argv2fp);
		fclose(argv2fp2);
	}
	hdestroy();
	printf("Number of pages in=%d, hashconflicts=%d, zeropagecount=%d+1\n Test results are in a file named outputdata\n",debugcount,hashconflict,zeropagecount);	
	return 0;	
}

void number_of_zeropages(void){
	ENTRY e, *ep;
	FILE *tmpfp;
	tmpfp = fopen("/dev/zero", "r");
	fread(page3,FRAMESIZE,1,tmpfp);
	fclose(tmpfp);
	hash_data(page3,4096, digest);
	
	for (di = 0; di < 16; ++di)
		sprintf(hex_output + di * 2, "%02x", digest[di]);

	e.key = hex_output; 
	ep = hsearch(e,FIND);

	struct memdata *currentmem;
	struct filechain *currentfile;
	
	if( ep != NULL){

		currentmem = (struct memdata *) ep->data;
		currentfile = (struct filechain *) currentmem->filechain; 

		int goon;
		goon = 1;
		while(goon)	{
			if(currentfile->fileno == fileno(argv1fp2)){
				fp = argv1fp;
			} else {
				fp = argv2fp;
			}
			
			fseek(fp, (currentfile->filepointer) - FRAMESIZE, SEEK_SET);
			fread(page2,FRAMESIZE,1,fp);
			if(bcmp((void *) page3,(void *) page2, FRAMESIZE) == 0){
				zeropagecount = currentfile->count;
				goon = 0;
			} else if (currentfile != NULL) {			
				currentfile = currentfile->chain;
			} else 
				goon = 0;
		}
	}
}

void create_new_data(void){

	struct memdata *data;
	data =  (struct memdata *) malloc(sizeof(struct memdata));
	data->filechain = (struct filechain *) malloc(sizeof(struct filechain));
	dprintf("new memdata\n");
	data->link = lastnew;
	(data->filechain)->count = 0;
	(data->filechain)->filepointer = ftell(fp2);
	(data->filechain)->chain = NULL;
	(data->filechain)->fileno = fileno(fp2);
	
	lastnew = data;
	e.data = (void *)data;
	ep = hsearch(e, ENTER);
	if(ep == NULL) {
		fprintf(stderr, "entry failed\n");
		exit(1);
	}	
}

void hash_match(void){ 
 
	currentmem = (struct memdata *) ep->data;
	currentfile = (struct filechain *) currentmem->filechain; 
			
	int goon;
	goon = 1;
	while(goon){
		if(currentfile->fileno == fileno(argv1fp2)){
			fp = argv1fp;
		} else {
			fp = argv2fp;
		}
		
		fseek(fp, (currentfile->filepointer) - FRAMESIZE, SEEK_SET);
		fread(page2,FRAMESIZE,1,fp);
		if(bcmp((void *) page,(void *) page2, FRAMESIZE) == 0){
			currentfile->count++;
			goon = 0;
			dprintf("match\n");
		} else {
			if(currentfile->chain == NULL) {
				currentfile->chain = (struct filechain *) malloc(sizeof(struct filechain));
				currentfile->chain->filepointer = ftell(fp2);
				currentfile->chain->count = 0;
				currentfile->chain->chain = NULL;
				currentfile->chain->fileno = fileno(fp2);
				goon = 0;
				hashconflict++;
				dprintf("chaininserted");
			} else {
				currentfile = currentfile->chain;
				dprintf("chainfollow");
			}
		}  
	}
}
 
void write_data(int zeropagecount){
	
	FILE *fp3;
	fp3 = fopen("outputdata","w");
	void *freeit;
	void *freechain;	

	do{
		currentfile = lastnew->filechain;
		do{
			fprintf(fp3,"%d\n",currentfile->count);
			freechain = currentfile;
			currentfile = currentfile->chain;
			free(freechain);
		}while(currentfile != NULL);
		freeit = lastnew;
		lastnew=lastnew->link;
		free((void *) freeit);
		
	} while(lastnew != NULL);
	
	if(zeropagecount == 0) 
		fprintf(fp3,"ED\n0\n");
	else 
		fprintf(fp3,"ED\n%d\n",zeropagecount + 1 );
	fclose(fp3);
}
