#!/usr/bin/env python

import sys

def getMemDetail(detail):
	""" Search in /proc/meminfo for detail. Returns an integer"""
	f = open("/proc/meminfo", "r")
	for line in f.readlines():
		if detail in line:
			bp = line.find(":")
			op = line[bp+1:].strip()
			size = op.split(" ")[0]
			return int(size)

cacheuse = getMemDetail("Cache")
totalmem = getMemDetail("MemTotal")
nopages = (totalmem * 1024) / 4096 #calculate number of pages
pagecount = -1

def printstatus():
	"""Print status info"""
	print "Total Mem: " + str(totalmem)
	print "Cache Used: " + str(cacheuse)
	print "Number Of Pages: " + str(nopages)
	print "Pages Counted: " + str(pagecount)


fi = open("/dev/mem", mode="rb", buffering=0) #open in binary read mode without buffering
fo = open("memimage", mode="wb", buffering=0) #same, just write

while pagecount < nopages:
	pagecount += 1
	try:
		fi.seek(pagecount * 4096) #read next page
		fo.write(fi.read(4096)) #write page
	except:
		print "Error"
		printstatus()
		sys.exit()

#cleanup
printstatus()
fi.close()
fo.close()
